Namespace SudokuEvo
  Friend Class SudokuEvoProgram
	Private Shared rnd As New Random(0)

	Shared Sub Main(ByVal args() As String)
	  Console.WriteLine(vbCrLf & "Begin solving Sudoku using combinatorial evolution " & vbCrLf)
	  Console.WriteLine(vbCrLf & "The problem is: " & vbCrLf)
            Dim problem(8)() As Integer
            ' August 2014 MSDN article problem -- difficult
            ' solved using no = 200, me = 5000
            problem(0) = New Integer() { 0, 0, 6, 2, 0, 0, 0, 8, 0 }
	  problem(1) = New Integer() { 0, 0, 8, 9, 7, 0, 0, 0, 0 }
	  problem(2) = New Integer() { 0, 0, 4, 8, 1, 0, 5, 0, 0 }

	  problem(3) = New Integer() { 0, 0, 0, 0, 6, 0, 0, 0, 2 }
	  problem(4) = New Integer() { 0, 7, 0, 0, 0, 0, 0, 3, 0 }
	  problem(5) = New Integer() { 6, 0, 0, 0, 5, 0, 0, 0, 0 }

	  problem(6) = New Integer() { 0, 0, 2, 0, 4, 7, 1, 0, 0 }
	  problem(7) = New Integer() { 0, 0, 3, 0, 2, 8, 4, 0, 0 }
	  problem(8) = New Integer() { 0, 5, 0, 0, 0, 1, 2, 0, 0 }

            '// http://ieeexplore.ieee.org/stamp/stamp.jsp?tp=&arnumber=5412260
            '// very difficult.
            '// solved using no = 200, me = 9000
            'problem(0) = new Integer() { 0, 0, 0, 0, 7, 0, 0, 0, 0 };
            'problem(1) = new Integer() { 0, 9, 0, 5, 0, 6, 0, 8, 0 };
            'problem(2) = new Integer() { 0, 0, 8, 4, 0, 1, 2, 0, 0 };

            'problem(3) = new Integer() { 0, 5, 9, 0, 0, 0, 8, 4, 0 };
            'problem(4) = new Integer() { 7, 0, 0, 0, 0, 0, 0, 0, 6 };
            'problem(5) = new Integer() { 0, 2, 3, 0, 0, 0, 5, 7, 0 };

            'problem(6) = new Integer() { 0, 0, 5, 3, 0, 7, 4, 0, 0 };
            'problem(7) = new Integer() { 0, 1, 0, 6, 0, 8, 0, 9, 0 };
            'problem(8) = new Integer() { 0, 0, 0, 0, 1, 0, 0, 0, 0 };

            '// easy
            '// solved quickly with almost any reasonable no, me
            'problem(0) = new Integer() { 0, 0, 7, 0, 0, 2, 9, 3, 0 };
            'problem(1) = new Integer() { 0, 8, 1, 0, 0, 0, 0, 0, 5 };
            'problem(2) = new Integer() { 9, 0, 4, 7, 0, 0, 1, 6, 0 };

            'problem(3) = new Integer() { 0, 1, 0, 8, 0, 0, 0, 0, 6 };
            'problem(4) = new Integer() { 8, 4, 6, 0, 0, 0, 5, 9, 2 };
            'problem(5) = new Integer() { 5, 0, 0, 0, 0, 6, 0, 1, 0 };

            'problem(6) = new Integer() { 0, 9, 2, 0, 0, 8, 3, 0, 1 };
            'problem(7) = new Integer() { 4, 0, 0, 0, 0, 0, 6, 5, 0 };
            'problem(8) = new Integer() { 0, 6, 5, 4, 0, 0, 2, 0, 0 };

            '// http://elmo.sbs.arizona.edu/sandiway/sudoku/examples.html
            '// EXTREMELY difficult.
            '// solved quickly using no = 100, me = 19,000
            'problem(0) = new Integer() { 0, 0, 0, 6, 0, 0, 4, 0, 0 };
            'problem(1) = new Integer() { 7, 0, 0, 0, 0, 3, 6, 0, 0 };
            'problem(2) = new Integer() { 0, 0, 0, 0, 9, 1, 0, 8, 0 };

            'problem(3) = new Integer() { 0, 0, 0, 0, 0, 0, 0, 0, 0 };
            'problem(4) = new Integer() { 0, 5, 0, 1, 8, 0, 0, 0, 3 };
            'problem(5) = new Integer() { 0, 0, 0, 3, 0, 6, 0, 4, 5 };

            'problem(6) = new Integer() { 0, 4, 0, 2, 0, 0, 0, 6, 0 };
            'problem(7) = new Integer() { 9, 0, 3, 0, 0, 0, 0, 0, 0 };
            'problem(8) = new Integer() { 0, 2, 0, 0, 0, 0, 1, 0, 0 };

            '// http://elmo.sbs.arizona.edu/sandiway/sudoku/examples.html
            '// most difficult problem found by Internet search.
            '// solved eventually using no = 100, me = 5,000.
            '// solution when seed = 577 (i.e., 577 attempts ~ 20 min.)
            'problem(0) = new Integer() { 0, 2, 0, 0, 0, 0, 0, 0, 0 };
            'problem(1) = new Integer() { 0, 0, 0, 6, 0, 0, 0, 0, 3 };
            'problem(2) = new Integer() { 0, 7, 4, 0, 8, 0, 0, 0, 0 };

            'problem(3) = new Integer() { 0, 0, 0, 0, 0, 3, 0, 0, 2 };
            'problem(4) = new Integer() { 0, 8, 0, 0, 4, 0, 0, 1, 0 };
            'problem(5) = new Integer() { 6, 0, 0, 5, 0, 0, 0, 0, 0 };

            'problem(6) = new Integer() { 0, 0, 0, 0, 1, 0, 7, 8, 0 };
            'problem(7) = new Integer() { 5, 0, 0, 0, 0, 9, 0, 0, 0 };
            'problem(8) = new Integer() { 0, 0, 0, 0, 0, 0, 0, 4, 0 };

            DisplayMatrix(problem)

            Dim numOrganisms As Integer = 200
	  Dim maxEpochs As Integer = 5000
	  Dim maxRestarts As Integer = 40
	  Console.WriteLine("Setting numOrganisms = " & numOrganisms)
	  Console.WriteLine("Setting maxEpochs    = " & maxEpochs)
	  Console.WriteLine("Setting maxRestarts  = " & maxRestarts)

            Dim soln()() As Integer = Solve(problem, numOrganisms, maxEpochs, maxRestarts)
            Console.WriteLine(vbCrLf & "Best solution found: " & vbCrLf)
	  DisplayMatrix(soln)

	  Dim err As Integer = [Error](soln)
	  If err = 0 Then
		Console.WriteLine("Success " & vbCrLf)
	  Else
		Console.WriteLine("Did not find optimal solution " & vbCrLf)
	  End If

	  Console.WriteLine("End Sudoku using combinatorial evolution " & vbCrLf)

	  Console.ReadLine()
	End Sub ' Main()

        Public Shared Function Solve(ByVal problem()() As Integer, ByVal numOrganisms As Integer, ByVal maxEpochs As Integer, ByVal maxRestarts As Integer) As Integer()()
            ' wrapper for SolveEvo()
            Dim err As Integer = Integer.MaxValue
            Dim seed As Integer = 0
            Dim best()() As Integer = Nothing
            Dim attempt As Integer = 0
            Do While err <> 0 AndAlso attempt < maxRestarts
                Console.WriteLine(vbCrLf & "seed = " & seed)
                rnd = New Random(seed)
                best = SolveEvo(problem, numOrganisms, maxEpochs) ' things, maxEpochs
                err = [Error](best)
                seed += 1
                attempt += 1
            Loop

            Return best
        End Function ' Solve

        Public Shared Sub DisplayMatrix(ByVal matrix()() As Integer)
            For r = 0 To 8
                If r = 3 OrElse r = 6 Then
                    Console.WriteLine("")
                End If
                For c = 0 To 8
                    If c = 3 OrElse c = 6 Then
                        Console.Write(" ")
                    End If
                    If matrix(r)(c) = 0 Then
                        Console.Write(" _")
                    Else
                        Console.Write(" " & matrix(r)(c))
                    End If
                Next c
                Console.WriteLine("")
            Next r
            Console.WriteLine(vbCrLf)
        End Sub

        Public Shared Function SolveEvo(ByVal problem()() As Integer, ByVal numOrganisms As Integer, ByVal maxEpochs As Integer) As Integer()()
            ' initialize combinatorial Organisms
            Dim numWorker As Integer = CInt(Fix(numOrganisms * 0.9))
            Dim numExplorer As Integer = numOrganisms - numWorker
            Dim hive(numOrganisms - 1) As Organism

            Dim bestError As Integer = Integer.MaxValue
            Dim bestMatrix()() As Integer = Nothing

            Dim organismType As Integer = -1
            For i = 0 To numOrganisms - 1
                If i < numWorker Then
                    organismType = 0 ' worker
                Else
                    organismType = 1 ' explorer
                End If

                Dim rndMatrix()() As Integer = RandomMatrix(problem)
                Dim err As Integer = [Error](rndMatrix)

                hive(i) = New Organism(organismType, rndMatrix, err, 0)

                If err < bestError Then
                    bestError = err
                    bestMatrix = DuplicateMatrix(rndMatrix) ' by value
                End If
            Next i

            ' main loop
            Dim epoch As Integer = 0
            Do While epoch < maxEpochs
                If epoch Mod 1000 = 0 Then
                    Console.Write("epoch = " & epoch)
                    Console.WriteLine(" best error = " & bestError)
                End If

                If bestError = 0 Then ' solution found
                    Exit Do
                End If

                ' process each organism
                For i = 0 To numOrganisms - 1
                    If hive(i).type = 0 Then ' worker
                        Dim neighbor()() As Integer = NeighborMatrix(problem, hive(i).matrix)
                        Dim err As Integer = [Error](neighbor)

                        Dim p As Double = rnd.NextDouble
                        If err < hive(i).error OrElse p < 0.001 Then ' better, or a mistake
                            hive(i).matrix = DuplicateMatrix(neighbor) ' by value
                            hive(i).error = err
                            If err < hive(i).error Then
                                hive(i).age = 0
                            End If

                            If err < bestError Then
                                bestError = err
                                bestMatrix = DuplicateMatrix(neighbor)
                            End If
                        Else ' neighbor is not better
                            hive(i).age += 1
                            If hive(i).age > 1000 Then ' die
                                Dim m()() As Integer = RandomMatrix(problem)
                                hive(i) = New Organism(0, m, [Error](m), 0)
                            End If
                        End If ' worker
                    ElseIf hive(i).type = 1 Then ' explorer
                        Dim rndMatrix()() As Integer = RandomMatrix(problem)
                        hive(i).matrix = DuplicateMatrix(rndMatrix)
                        hive(i).error = [Error](rndMatrix)

                        If hive(i).error < bestError Then
                            bestError = hive(i).error
                            bestMatrix = DuplicateMatrix(rndMatrix)
                        End If
                    End If
                Next i ' each organism

                ' merge best worker with best explorer into worst worker
                Dim bestwi As Integer = 0 ' index of best worker
                Dim smallestWorkerError As Integer = hive(0).error
                For i = 0 To numWorker - 1
                    If hive(i).error < smallestWorkerError Then
                        smallestWorkerError = hive(i).error
                        bestwi = i
                    End If
                Next i

                Dim bestei As Integer = numWorker ' index of best explorer
                Dim smallestExplorerError As Integer = hive(numWorker).error
                For i = numWorker To numOrganisms - 1
                    If hive(i).error < smallestExplorerError Then
                        smallestExplorerError = hive(i).error
                        bestei = i
                    End If
                Next i

                Dim worstwi As Integer = 0 ' index of worst worker
                Dim largestWorkerError As Integer = hive(0).error
                For i = 0 To numWorker - 1
                    If hive(i).error > largestWorkerError Then
                        largestWorkerError = hive(i).error
                        worstwi = i
                    End If
                Next i

                Dim merged()() As Integer = MergeMatrices(hive(bestwi).matrix, hive(bestei).matrix)

                hive(worstwi) = New Organism(0, merged, [Error](merged), 0)
                If hive(worstwi).error < bestError Then
                    bestError = hive(worstwi).error
                    bestMatrix = DuplicateMatrix(merged)
                End If

                epoch += 1
            Loop ' while

            Return bestMatrix
        End Function ' SolveEvo

        Public Shared Function RandomMatrix(ByVal problem()() As Integer) As Integer()()
            ' fill each 3x3 block with 1-9
            Dim result()() As Integer = DuplicateMatrix(problem)

            For BlockData = 0 To 8
                Dim corners() As Integer = Corner(BlockData)
                Dim vals As New List(Of Integer)(9)
                For i = 1 To 9
                    vals.Add(i)
                Next i

                ' shuffle
                For k = 0 To vals.Count - 1
                    Dim ri As Integer = rnd.Next(k, vals.Count)
                    Dim tmp As Integer = vals(k)
                    vals(k) = vals(ri)
                    vals(ri) = tmp
                Next k

                ' walk thru block and remove from list starting numbers in problem
                Dim r As Integer = corners(0)
                Dim c As Integer = corners(1)
                For i = r To r + 3 - 1
                    For j = c To c + 3 - 1
                        Dim v As Integer = problem(i)(j)
                        If v <> 0 Then ' a fixed starting number
                            vals.Remove(v)
                        End If
                    Next j
                Next i

                ' walk thru block and add values
                Dim ptr As Integer = 0 ' pointer into List
                For i = r To r + 3 - 1
                    For j = c To c + 3 - 1
                        If result(i)(j) = 0 Then ' not occupied
                            Dim v As Integer = vals(ptr) ' get value from List
                            result(i)(j) = v
                            ptr += 1 ' move to next value in List
                        End If
                    Next j
                Next i
            Next BlockData ' each block, k

            Return result
        End Function ' RandomMatrix

        Public Shared Function Corner(ByVal block As Integer) As Integer()
	  Dim r As Integer = -1, c As Integer = -1

	  If block = 0 OrElse block = 1 OrElse block = 2 Then
		r = 0
	  ElseIf block = 3 OrElse block = 4 OrElse block = 5 Then
		r = 3
	  ElseIf block = 6 OrElse block = 7 OrElse block = 8 Then
		r = 6
	  End If

	  If block = 0 OrElse block = 3 OrElse block = 6 Then
		c = 0
	  ElseIf block = 1 OrElse block = 4 OrElse block = 7 Then
		c = 3
	  ElseIf block = 2 OrElse block = 5 OrElse block = 8 Then
		c = 6
	  End If

	  Return New Integer() { r, c }
	End Function

        Public Shared Function Block(ByVal r As Integer, ByVal c As Integer) As Integer
            If r >= 0 AndAlso r <= 2 AndAlso c >= 0 AndAlso c <= 2 Then
                Return 0
            ElseIf r >= 0 AndAlso r <= 2 AndAlso c >= 3 AndAlso c <= 5 Then
                Return 1
            ElseIf r >= 0 AndAlso r <= 2 AndAlso c >= 6 AndAlso c <= 8 Then
                Return 2
            ElseIf r >= 3 AndAlso r <= 5 AndAlso c >= 0 AndAlso c <= 2 Then
                Return 3
            ElseIf r >= 3 AndAlso r <= 5 AndAlso c >= 3 AndAlso c <= 5 Then
                Return 4
            ElseIf r >= 3 AndAlso r <= 5 AndAlso c >= 6 AndAlso c <= 8 Then
                Return 5
            ElseIf r >= 6 AndAlso r <= 8 AndAlso c >= 0 AndAlso c <= 2 Then
                Return 6
            ElseIf r >= 6 AndAlso r <= 8 AndAlso c >= 3 AndAlso c <= 5 Then
                Return 7
            ElseIf r >= 6 AndAlso r <= 8 AndAlso c >= 6 AndAlso c <= 8 Then
                Return 8
            Else
                Throw New Exception("Unable to find Block()")
            End If
        End Function

        Public Shared Function NeighborMatrix(ByVal problem()() As Integer, ByVal matrix()() As Integer) As Integer()()
            ' pick a random 3x3 block,
            ' pick two random cells in block
            ' swap values

            Dim result()() As Integer = DuplicateMatrix(matrix)

            Dim block As Integer = rnd.Next(0, 9) ' 0,8
            'Console.WriteLine("block = " + block);
            Dim corners() As Integer = Corner(block)
            'Console.WriteLine("corners = " + corners0 + " " + corners1);
            Dim cells As New List(Of Integer())
            For i = corners(0) To corners(0) + 3 - 1
                For j = corners(1) To corners(1) + 3 - 1
                    'Console.WriteLine("problem " + i + " " + j + " = " + problemij);
                    If problem(i)(j) = 0 Then ' a non-fixed value
                        cells.Add(New Integer() {i, j})
                    End If
                Next j
            Next i

            If cells.Count < 2 Then
                Console.WriteLine("Cells count = " & cells.Count)
                Throw New Exception("block " & block & " doesn't have two values to swap!")
            End If

            ' pick two. suppose there are 4 possible cells 0,1,2,3
            Dim k1 As Integer = rnd.Next(0, cells.Count) ' 0,1,2,3
            Dim inc As Integer = rnd.Next(1, cells.Count) ' 1,2,3
            Dim k2 As Integer = (k1 + inc) Mod cells.Count
            'Console.WriteLine("k1 k2 = " + k1 + " " + k2);

            Dim r1 As Integer = cells(k1)(0)
            Dim c1 As Integer = cells(k1)(1)
            Dim r2 As Integer = cells(k2)(0)
            Dim c2 As Integer = cells(k2)(1)

            'Console.WriteLine("r1 c1 = " + r1 + " " + c1);
            'Console.WriteLine("r2 c2 = " + r2 + " " + c2);

            Dim tmp As Integer = result(r1)(c1)
            result(r1)(c1) = result(r2)(c2)
            result(r2)(c2) = tmp

            Return result
        End Function ' NeighborMatrix

        Public Shared Function MergeMatrices(ByVal m1()() As Integer, ByVal m2()() As Integer) As Integer()()
            Dim result()() As Integer = DuplicateMatrix(m1)

            For BlockData = 0 To 8
                Dim pr As Double = rnd.NextDouble
                If pr < 0.5 Then
                    Dim corners() As Integer = Corner(BlockData)
                    For i = corners(0) To corners(0) + 3 - 1
                        For j = corners(1) To corners(1) + 3 - 1
                            result(i)(j) = m2(i)(j)
                        Next j
                    Next i
                End If
            Next BlockData

            Return result
        End Function

        Public Shared Function [Error](ByVal matrix()() As Integer) As Integer
            Dim err As Integer = 0
            ' assumes blocks are OK (one each 1-9)

            ' rows error
            For i = 0 To 8 ' each row
                Dim counts(8) As Integer ' 0 = count of 1s, 1 = count of 2s
                For j = 0 To 8 ' walk down column of curr row
                    Dim v As Integer = matrix(i)(j) ' 1 to 9
                    counts(v - 1) += 1
                Next j

                For k = 0 To 8 ' number missing
                    If counts(k) = 0 Then
                        err += 1
                    End If
                Next k
            Next i ' each row

            ' columns error
            For j = 0 To 8 ' each column
                Dim counts(8) As Integer ' 0 = count of 1s, 1 = count of 2s

                For i = 0 To 8 ' walk down
                    Dim v As Integer = matrix(i)(j) ' 1 to 9
                    counts(v - 1) += 1 ' counts0-8
                Next i

                For k = 0 To 8 ' number missing in the colum
                    If counts(k) = 0 Then
                        err += 1
                    End If
                Next k
            Next j ' each column

            Return err
        End Function ' Error

        Public Shared Function DuplicateMatrix(ByVal matrix()() As Integer) As Integer()()
            Dim result()() As Integer = CreateMatrix(9)
            For i = 0 To 8
                For j = 0 To 8
                    result(i)(j) = matrix(i)(j)
                Next j
            Next i
            Return result
        End Function

        Public Shared Function CreateMatrix(ByVal n As Integer) As Integer()()
            Dim result(n - 1)() As Integer
            For i = 0 To n - 1
                result(i) = New Integer(n - 1) {}
            Next i
            Return result
        End Function
    End Class ' SudokuEvoProgram

  Public Class Organism
	Public type As Integer ' 0 = worker, 1 = explorer
        Public matrix As Integer()()
        Public [error] As Integer
	Public age As Integer

        Public Sub New(ByVal type As Integer, ByVal m()() As Integer, ByVal [error] As Integer, ByVal age As Integer)
            Me.type = type
            Me.matrix = SudokuEvoProgram.DuplicateMatrix(m)
            Me.error = [error]
            Me.age = age
        End Sub
    End Class
End Namespace ' ns
